Codeforces-687C The Values You Can Make

Pari wants to buy an expensive chocolate from Arya. She has n coins, the value of the i-th coin is ci. The price of the chocolate is k, so Pari will take a subset of her coins with sum equal to k and give it to Arya.

Looking at her coins, a question came to her mind: after giving the coins to Arya, what values does Arya can make with them? She is jealous and she doesn't want Arya to make a lot of values. So she wants to know all the values x, such that Arya will be able to make xusing some subset of coins with the sum k.

Formally, Pari wants to know the values x such that there exists a subset of coins with the sum k such that some subset of this subset has the sum x, i.e. there is exists some way to pay for the chocolate, such that Arya will be able to make the sum x using these coins.

Input

The first line contains two integers n and k (1  ≤  n, k  ≤  500) — the number of coins and the price of the chocolate, respectively.

Next line will contain n integers c1, c2, ..., cn (1 ≤ ci ≤ 500) — the values of Pari's coins.

It's guaranteed that one can make value k using these coins.

Output

First line of the output must contain a single integer q— the number of suitable values x. Then print q integers in ascending order — the values that Arya can make for some subset of coins of Pari that pays for the chocolate.

Examples
input
6 18
5 6 1 10 12 2
output
16
0 1 2 3 5 6 7 8 10 11 12 13 15 16 17 18 
input
3 50
25 25 50
output
3
0 25 50 


题目大意:
给你n个数,让你用这n个数在组成k的情况下,找到所有的value,这些value也由这n个数组成,且这些value组合在一起能够组成k
解法:
看到题目我的想法就是母函数= =不过wa了,后来发现因为母函数能找到这n个数所能形成的所有情况,但是可能两种情况是包含关系的。比如3,3,6这个数据可以形成6和9但是如果k是15的时候,你就不能得到因为9是由6生成的
dp[i][j]表示在和为i的情况下,能否得到j
那么当dp[i][j] = 1时,dp[i][j + c[k]]比然能得到,dp[i+c[k]][j+c[k]]也能得到。
以下是代码:
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
const int maxn = 500 + 5;
int c[maxn], res[maxn], dp[maxn][maxn];
int main()
{
	int n, K;
	scanf("%d%d", &n, &K);
	for(int i = 0; i < n; ++i){
		scanf("%d", &c[i]);
	}
	sort(c, c + n);
	memset(dp, 0, sizeof(dp));
	dp[0][0] = 1;
	for(int i = 0; i < n; ++i){
		for(int j = K; j >= c[i]; --j){
			for(int k = 0; k + c[i] <= K; ++k){
				if(dp[j - c[i]][k]) dp[j][k] = dp[j][k + c[i]] = 1;
			}
		}
	}
	int ans = 0;
	for(int i = 0; i <= K; ++i)
		if(dp[K][i]) res[ans++] = i;
	printf("%d
", ans);
	for(int i = 0; i < ans; ++i){
		printf("%d%c", res[i], (i == (ans - 1) ? '
' : ' '));
	}
	return 0;
}


原文地址:https://www.cnblogs.com/wiklvrain/p/8179469.html